//Title: Tommy Gun
//Author: Amade and Renshaw
//A submachine gun iconic of the 1930s.
//texture fixes and added recoil

//Script by Amade, model by Absolution
datablock AudioProfile(TommyGunShotSound)
{
   filename    = "./TommyGunFire.wav"; //Thanks to ClickTeam for the sound (Company, not a user).
   description = AudioClose3d;
   preload     = true;
};

AddDamageType("TommyGun", '<bitmap:add-ons/GameMode_Legend_of_Blockhead/addons/tommy/TommyGun_CI> %1', '%2 <bitmap:add-ons/GameMode_Legend_of_Blockhead/addons/tommy/TommyGun_CI> %1',0.2,1);

datablock ProjectileData(TommyGunProjectile : gunProjectile)
{
   directDamage     = 8;
   directDamageType = $DamageType::TommyGun;
   radiusDamageType = $DamageType::TommyGun;
   impactImpulse    = 100;
   verticalImpulse  = 10;
   muzzleVelocity   = 135;
   velInheritFactor = 1;
   uiName           = "Tommy Gun Bullet";
};

datablock ItemData(TommyGunItem : GunItem)
{
   shapeFile       = "./TommyGun.dts";
   uiName          = "Tommy Gun";
   iconName        = "./TommyGun_Icon";
   doColorShift    = false;
   colorShiftColor = "0 0 0 1";

   image   = TommyGunImage;
   canDrop   = true;
};

datablock ShapeBaseImageData(TommyGunImage : GunImage)
{
   shapeFile  = TommyGunItem.shapeFile;
   projectile = TommyGunProjectile;

   doColorShift    = TommyGunItem.doColorShift;
   colorShiftColor = TommyGunItem.colorShiftColor;

   stateName[0]                   = "Activate";
   stateTimeoutValue[0]           = 0.15;
   stateTransitionOnTimeout[0]    = "Ready";
   stateSound[0]                  = weaponSwitchSound;

   stateName[1]                   = "Ready";
   stateTransitionOnTriggerDown[1]= "Fire";
   stateAllowImageChange[1]       = true;
   stateSequence[1]               = "Ready";

   stateName[2]                   = "Fire";
   stateTransitionOnTimeout[2]    = "Reload";
   stateTimeoutValue[2]           = 0.075;
   stateFire[2]                   = true;
   stateAllowImageChange[2]       = false;
   stateSequence[2]               = "Fire";
   stateScript[2]                 = "onFire";
   stateWaitForTimeout[2]         = true;
   stateEmitter[2]                = gunFlashEmitter;
   stateEmitterTime[2]            = 0.05;
   stateEmitterNode[2]            = "muzzleNode";
   stateSound[2]                  = TommyGunShotSound;
   stateEjectShell[2]             = true;

   stateName[3]                   = "Smoke";
   stateEmitter[3]                = gunSmokeEmitter;
   stateEmitterTime[3]            = 0.5;
   stateEmitterNode[3]            = "muzzleNode";
   stateTimeoutValue[3]           = 0.01;
   stateTransitionOnTimeout[3]    = "Ready";

   stateName[4]                   = "Reload";
   stateSequence[4]               = "Reload";
   stateTransitionOnTriggerUp[4]  = "Smoke";
   stateTransitionOnTriggerDown[4]= "Fire";
   stateSequence[4]               = "Ready";
};

//Ephialtes' bullet spread coding
function TommyGunImage::onFire(%this, %obj, %slot)
{
   %spread = 0.00175;
   %projectile = %this.projectile;
   %vector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
   %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
   %velocity = VectorAdd(%vector1,%vector2);
   %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
   %velocity = MatrixMulVector(%mat, %velocity);
   %p = new (%this.projectileType)()
   {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
   };
   MissionCleanup.add(%p);

	%obj.setVelocity(VectorAdd(%obj.getVelocity(), VectorScale(%obj.client.player.getEyeVector(),"-1")));
}