exec("./items.cs");
exec("./package.cs");

function Dungeon_Tick() //tick to do other things, runs independently of rounds and the minigame
{
	cancel($Dungeon::Tick);
	
	//apply hud to players
	for(%a = 0; %a < $DefaultMinigame.numMembers; %a++)
	{
		%member = $DefaultMinigame.member[%a];
		if(isObject(%member))
			%member.setDungeonBottomPrintInfo();
	}
	
	$Dungeon::Tick = schedule(100, 0, Dungeon_Tick);
}

function gameConnection::setDungeonBottomPrintInfo(%this)
{
	%player = %this.player;
	if(isObject(%player))
	{
		//left
		%this.DungeonBottomPrint = "<just:left>";
		
		%data = %player.getDatablock();
		%this.maxHealth = %data.maxDamage;
		%this.currHealth = %data.maxDamage - %player.getDamageLevel();
		
		//get max health
		if(%this.maxHealth > 0)
		{
			%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "\c6Health";
			
			if(mceil(%this.currHealth) > %this.maxHealth)
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "\c4: " @ mceil(%this.currHealth) @ "\c6/\c4" @ %this.maxHealth;
			else if(%this.currHealth > 90)
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "<color:33ff00>: " @ mceil(%this.currHealth) @ "\c6/<color:33ff00>" @ %this.maxHealth;
			else if(%this.currHealth > 80)
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "<color:66ff00>: " @ mceil(%this.currHealth) @ "\c6/<color:66ff00>" @ %this.maxHealth;
			else if(%this.currHealth > 70)
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "<color:99ff00>: " @ mceil(%this.currHealth) @ "\c6/<color:99ff00>" @ %this.maxHealth;
			else if(%this.currHealth > 60)
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "<color:ccff00>: " @ mceil(%this.currHealth) @ "\c6/<color:ccff00>" @ %this.maxHealth;
			else if(%this.currHealth > 50)
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "\c3: " @ mceil(%this.currHealth) @ "\c6/\c3" @ %this.maxHealth;
			else if(%this.currHealth > 40)
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "<color:ffcc00>: " @ mceil(%this.currHealth) @ "\c6/<color:ffcc00>" @ %this.maxHealth;
			else if(%this.currHealth > 30)
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "<color:ff9900>: " @ mceil(%this.currHealth) @ "\c6/<color:ff9900>" @ %this.maxHealth;
			else if(%this.currHealth > 20)
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "<color:ff6600>: " @ mceil(%this.currHealth) @ "\c6/<color:ff6600>" @ %this.maxHealth;
			else if(%this.currHealth > 10)
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "<color:ff3300>: " @ mceil(%this.currHealth) @ "\c6/<color:ff3300>" @ %this.maxHealth;
			else
				%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "\c0: " @ mceil(%this.currHealth) @ "\c6/\c0" @ %this.maxHealth;
		}
		
		//bonus health
		if(%player.DM_HealthShield > 0)
			%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "\c3 + " @ mceil(%player.DM_HealthShield);
		
		//right
		%this.DungeonBottomPrint = %this.DungeonBottomPrint @ "<just:right>";
		
		//score
		%this.DungeonBottomPrint = %this.DungeonBottomPrint @ " \c6Score\c3: " @ mfloor(%this.score);
	}
	else
		%this.DungeonBottomPrint = "";
	
	//completed building it, send it.
	commandToClient(%this, 'bottomPrint', %this.DungeonBottomPrint, 0, true);
}