if(isPackage(DungeonPackage))
	deactivatePackage(DungeonPackage);
package DungeonPackage
{
	//this is called when save loading finishes 
	function GameModeInitialResetCheck()
	{
		Parent::GameModeInitialResetCheck();
		$Server::MaxPlayerVehicles_Total = 1000;
		$DefaultMiniGame.scheduleReset();
	}
	
	function GameConnection::incScore(%this, %amount)
	{
		Parent::incScore(%this, %amount);
		
		if(%amount > 0)
			centerPrint(%this, "<just:right>\c3+" @ %amount @ " \c6points ", 5);
		else if(%amount < 0)
			centerPrint(%this, "<just:right>\c0" @ %amount @ " \c6points ", 5);
	}
	
	function Armor::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
	{
		if(mabs(%obj.DM_HealthShield) > 0)
		{
			if(%damage > %obj.DM_HealthShield)
			{
				%damage -= %obj.DM_HealthShield;
				%obj.DM_HealthShield = 0;
			}
			else
			{
				%obj.DM_HealthShield -= %damage;
				%damage = 0;
			}
		}
		
		Parent::damage(%this, %obj, %sourceObject, %position, %damage, %damageType);
	}
	
	function WeaponImage::onMount(%this, %obj, %slot)
	{
		Parent::onMount(%this, %obj, %slot);
		if(!isObject(%obj))
			return;
		
		%client = %obj/client;
		if(!isObject(%client))
			return;
		
		//right
		%itemInfo = "<just:right>";
		
		//name
		if(%this.dungeonName $= "")
			%itemInfo = %itemInfo @ "\c3" @ %this.uiName @ "<br>";
		else
			%itemInfo = %itemInfo @ "\c3" @ %this.dungeonName @ "<br>";
		
		//active
		//if(%this.dungeonActive !$= "")
		//	%itemInfo = %itemInfo @ "\c3Active\c6: " @ %this.dungeonActive @ "<br>";
		
		//passive
		//if(%this.dungeonPassive !$= "")
		//	%itemInfo = %itemInfo @ "\c3Passive\c6: " @ %this.dungeonPassive @ "<br>";
		
		//description
		if(%this.dungeonDescription !$= "")
			%itemInfo = %itemInfo @ "\c6" @ %this.dungeonDescription;
		
		centerPrint(%client, %itemInfo, 12);
	}
	
	function serverCmdleaveMiniGame(%client)
	{
		Parent::serverCmdleaveMiniGame(%client);
		commandToClient(%client, 'bottomPrint', "", 0, true);
	}
	
	function disconnect()
	{
		//Stops the ticks just incase you're not hosting a dedicated server. You should still restart blockland just to be safe and to minimise problems.
		if(!$Server::Dedicated)
			cancel($Dungeon::Tick);
		
		parent::disconnect();
	}
};
activatePackage(DungeonPackage);