//a copy of grapple rope that pulls the player in by shortening the rope as they hold.
datablock ProjectileData(PullerRopeProjectile)
{
	directDamage = 0;
	radiusDamage = 0;
	damageRadius = 0;

	muzzleVelocity = 200;
	velInheritFactor = 1;

	armingDelay = 0;
	lifetime = 4000;
	fadeDelay = 3500;
	bounceElasticity = 0;
	bounceFriction = 0;
	isBallistic = true;
	gravityMod = 0;

	hasLight = false;
	lightRadius	= 1.0;
	lightColor = "0 0 0";
};

datablock ItemData(PullerRope)
{
	category = "Tool";
	className = "Tool";

	shapeFile = "base/data/shapes/printGun.dts";
	mass = 1;
	density	= 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	uiName = "Puller Rope";
	iconName = "base/client/ui/itemIcons/printer";
	doColorShift = true;
	colorShiftColor = "1 0 1 1";

	image = PullerRopeImage;
	canDrop	= true;
};

datablock ShapeBaseImageData(PullerRopeImage)
{
	shapeFile = "base/data/shapes/printGun.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 .1";
	eyeOffset = "0.7 1.2 -0.55"; 
	correctMuzzleVector = true;
	className = "WeaponImage";

	item = PullerRope;
	ammo = " ";
	projectile = PullerRopeProjectile;
	projectileType = Projectile;

	melee = false;
	doRetraction = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = "1 0 1 1";
	
	raycastWeaponRange = 1000;
	raycastWeaponTargets = $TypeMasks::StaticObjectType | $TypeMasks::FXBrickObjectType;
	raycastExplosionProjectile = PullerRopeProjectile;
	raycastFromMuzzle = true;

	stateName[0]				= "Activate";
	stateTimeoutValue[0]	    = 0.2;
	stateTransitionOnTimeout[0] = "Ready";
	stateScript[0]				= "onRelease";
	stateSound[0]				= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;

	stateName[2]				= "Fire";
	stateTransitionOnTimeout[2] = "Hold";
	stateTimeoutValue[2]	    = 0.01;
	stateFire[2]				= true;
	stateAllowImageChange[2]    = false;
	stateSequence[2]		    = "Fire";
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]	    = true;
	stateSound[2]				= bowFireSound;

	stateName[3]				  = "Hold";
	stateTimeoutValue[3]		  = 0.01;
	stateScript[3]				  = "onHold";
	stateTransitionOnTimeout[3]	  = "Hold";
	stateTransitionOnTriggerUp[3] = "Release";

	statename[4]				= "Release";
	stateAllowImageChange[4]    = false;
	stateTimeoutValue[4]	    = 0.01;
	stateTransitionOnTimeout[4] = "Ready";
	stateScript[4]				= "onRelease";
};

function PullerRopeProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	if(!isObject(%obj.client.player))
		return;
	%ppos = %obj.client.player.getPosition();
	%scanTarg = ContainerRayCast(vectorAdd(%ppos, "0 0 1"), %pos, $TypeMasks::StaticObjectType);
	if(!%scanTarg || %scanTarg == %col)
	{
		%obj.client.player.pullRopeLength = vectorLen(vectorSub(%obj.client.player.getPosition(), %pos));
		%obj.client.player.PullerRopeTarget++;
		%obj.client.player.PullerRopeCol = %col;
		%obj.client.player.PullerRopePos = %pos;
	}
}

function PullerRopeImage::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
	if(!isObject(%obj.client.player))
		return;
	%ppos = %obj.client.player.getPosition();
	%scanTarg = ContainerRayCast(vectorAdd(%ppos, "0 0 1"), %pos, $TypeMasks::StaticObjectType);
	if(!%scanTarg || %scanTarg == %col)
	{
		%obj.client.player.pullRopeLength = vectorLen(vectorSub(%obj.client.player.getPosition(), %pos));
		%obj.client.player.PullerRopeTarget++;
		%obj.client.player.PullerRopeCol = %col;
		%obj.client.player.PullerRopePos = %pos;
	}
}

function PullerRopeImage::onHold(%this, %obj, %slot)
{
	if(%obj.PullerRopePos !$= "")
	{
		PullerRope(%obj.client.player, %obj.client.player.PullerRopeCol, %obj.client.player.PullerRopeTarget, %obj.client.player.PullerRopePos);

		%vec = VectorSub(%obj.client.player.PullerRopePos, %obj.getMuzzlePoint(%slot));
		%norm = VectorNormalize(%vec);
		%vel = VectorScale(%norm, 160);

      %p = new (%this.projectileType)()
      {
		dataBlock = ChainProjectile;
		initialVelocity = %vel;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
      };
	MissionCleanup.add(%p);
	}
}

function PullerRopeImage::onRelease(%this, %obj, %slot)
{
	%obj.PullerRopeTarget++;
	%obj.PullerRopePos = "";
}

function PullerRope(%obj, %targetObj, %target, %staticPos, %targetOffset)
{
	if(%obj.PullerRopeTarget != %target)
		return;
	if(!isObject(%obj))
		return;
	if(%obj.pullRopeLength > 5)
		%obj.pullRopeLength -= 0.3;
	%pos = %staticPos;
	%ppos = %obj.getPosition();
	%dist = getWord(%pos, 0) - getWord(%ppos, 0) SPC getWord(%pos, 1) - getWord(%ppos, 1) SPC getWord(%pos, 2) - getWord(%ppos, 2);
	%vel = %obj.getVelocity();
	%temp = vectorSub(vectorAdd(%ppos, vectorScale(%vel,1)), %pos);
	if(vectorLen(%temp) > %obj.pullRopeLength)
   {
      %temp2 = vectorSub(vectorAdd(vectorScale(%temp, %obj.pullRopeLength / vectorLen(%temp)), %pos), %ppos);
      %vel = vectorAdd(vectorScale(%temp2, vectorLen(%vel) / vectorLen(%temp2)), vectorScale(vectorSub(%pos, %ppos), 1 / vectorLen(vectorSub(%pos, %ppos))));
   }
   %obj.setVelocity(%vel);
}